﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SatikSudokuSolver
{
    class Program
    {
        static void Main(string[] args)
        {
            char answer;
            do
            {
                var board = ReadSudoku();
                SolveSudoku(board);

                Console.WriteLine("Solve next? (Y/N)");
                answer = Console.ReadKey().KeyChar;
            }
            while (answer == 'y');
        }

        static SudokuBoard ReadSudoku()
        {
            Console.WriteLine("Please enter sudoku lines. Use underscore character ('_') for empty spaces.");

            string sudokuStr = "";

            for (int y = 0; y < 9; y++)
            {
                sudokuStr += Console.ReadLine();
            }

            SudokuBoard board = new SudokuBoard(sudokuStr);

            Console.WriteLine("You entered following sudoku: ");
            board.Print();

            return board;
        }

        static void SolveSudoku(SudokuBoard board)
        {
            SudokuSolver solver = new SudokuSolver();

            DateTime beginT = DateTime.Now;
            solver.Solve(board);
            TimeSpan elapsedTime = DateTime.Now - beginT;

            if (board.IsSolved)
            {
                Console.WriteLine("Sudoku was solved in {0}.", elapsedTime);
                Console.WriteLine("The solution:");
                board.Print();
            }
            else
            {
                Console.WriteLine("The sudoku has no solution.");
            }
        }
    }
}
