﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Text;
using System.Threading.Tasks;

namespace Sudoku
{
    class Program
    {
        static void Main(string[] args)
        {
            Sudoku sudoku = new Sudoku();

            Console.WriteLine("Vítejte v řešiči sudoku. Zadávejte sudoku po řádcích, čísla oddělená mezerou. Pro prázdné pole zadejte '_'.");

            sudoku.pole = NactiVstup(); // Nacteni vstupu a zaroven vytvoreni dvojrozmerneho pole
            sudoku.Vyres();

            Console.WriteLine("Výsledek:");
            sudoku.Vypis();

            Console.WriteLine("Stiskem libovolného tlačítka odejdete.");
            Console.ReadKey();
        }

        static Bunka[,] NactiVstup()
        {
            Bunka[,] pole = new Bunka[9, 9];

            for (int i = 0; i < 9; i++)
            {
                string[] vstup = Console.ReadLine().Split(' ');

                do
                {
                    bool spravnyVstup = false;

                    for (int k = 0; k < 9; k++)
                    {
                        pole[i, k] = new Bunka();

                        if (vstup[k] != "_")
                        {
                            try
                            {
                                pole[i, k].Cislo = (sbyte)(sbyte.Parse(vstup[k].ToString()) - 1);
                                pole[i, k].Puvodni = true; // Nastaveni bunky vlastnosti 'Puvodni' na true, aby se pak pri reseni nemohla prepsat
                            }
                            catch
                            {
                                spravnyVstup = false;
                                break;
                            }

                            if (k == 8)
                                spravnyVstup = true;
                        }
                        else if (vstup[k] == "_")
                        {
                            pole[i, k].Cislo = -1;

                            if (k == 8)
                                spravnyVstup = true;

                        }
                        else
                        {
                            spravnyVstup = false;
                            break;
                        }
                    }

                    if (spravnyVstup)
                        break;

                    Console.WriteLine("Chybný vstup. Zadejte řádek znovu.");
                    vstup = Console.ReadLine().Split(' ');
                }
                while (true);
            }

            return pole;
        }
    }
}
