﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace sudoku
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.Title = "Řešič sudoku - Michael Škrášek";
            Console.ForegroundColor = ConsoleColor.White;
            Console.SetWindowSize(Console.WindowWidth, (int)(Console.LargestWindowHeight / 1.5));

            //pár zkoušených zadání
            //string task = "_ _ _ 1 _ 2 _ _ _\n3 _ 9 8 _ 4 1 _ 7\n8 _ _ _ _ _ _ _ 2\n_ 3 _ 4 _ 6 _ 7 _\n4 _ _ _ _ _ _ _ 1\n_ 1 _ 2 _ 5 _ 9 _\n5 _ _ _ _ _ _ _ 8\n1 _ 6 5 _ 3 9 _ 4\n_ _ _ 6 _ 8 _ _ _";
            //string task = "_ _ 8 7 _ _ _ _ _\n_ _ 4 _ _ 2 _ 3 _\n_ 1 _ _ 8 _ _ _ 7\n_ _ _ _ 3 6 5 _ 8\n_ _ 3 _ 7 _ 6 _ _\n7 _ 5 8 9 _ _ _ _\n1 _ _ _ 6 _ _ 9 _\n_ 3 _ 4 _ _ 2 _ _\n_ _ _ _ _ 9 3 _ _";
            //string task = "5 6 3 1 _ 7 8 _ 9\n2 8 1 _ 5 9 7 _ 3\n4 7 9 3 8 _ 5 _ 1\n3 9 7 _ 1 8 _ 5 _\n6 _ _ 9 3 5 _ 7 8\n8 _ 5 7 6 _ 3 9 _\n9 3 _ 5 7 1 6 8 _\n7 _ 6 8 9 3 _ 1 5\n1 5 8 _ _ _ 9 3 7";
            //string task = "8 _ 4 1 _ _ _ _ _\n6 _ _ 8 _ 3 4 _ _\n_ 2 _ _ _ 5 _ 8 3\n3 _ 2 _ 4 _ _ _ _\n_ _ 5 _ _ _ 9 _ _\n_ _ _ _ 5 _ 1 _ 4\n7 4 _ 2 _ _ _ 9 _\n_ _ 3 5 _ 9 _ _ 6\n_ _ _ _ _ 4 3 _ 2";

            string task = "";
            for (int i = 0; i < 9; i++)
            {
                Console.Write("{0}. řádek sudoky: ", i + 1);
                task += Console.ReadLine() + "\n";
            }

            Console.CursorVisible = false;

            bool loading = true;
            Sudoku sudoku = new Sudoku(task);
            Console.WriteLine("\n" + sudoku.ToString());

            //tahle část je zde jen kvuli hezkosti ... :D
            sudoku.NumberChanged += new NumberChangedEventHandler((Number n) =>
            {
                if (!loading)
                {
                    Console.ForegroundColor = ConsoleColor.Green;
                    int x = Console.CursorLeft, y = Console.CursorTop;
                    Console.SetCursorPosition(n.X * 2, (y - 10) + n.Y);
                    Console.Write(n.ToString());
                    Console.SetCursorPosition(x, y);
                    Console.ForegroundColor = ConsoleColor.White;
                }
            });

            loading = false;

            if (sudoku.Solve())
            {
                Console.WriteLine("zadání: \n" + task);
                Console.WriteLine("\nřešení: \n" + sudoku.ToString());
            }
            else
            {
                Console.WriteLine("Nepodařilo se nalézt řešení.");
            }
            Console.CursorVisible = true;
            Console.ReadLine();
        }
    }
}
