﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace sudoku
{
    public class SudokuData : object
    {
        private Number[,] data = new Number[9, 9];
        public Number[,] Data
        {
            get { return data; }
        }

        public Number this[int x, int y]
        {
            get { return data[x, y]; }
            set { data[x, y] = value; }
        }

        //kontroluje zda sloupec obsahuje číslo
        public bool ColumnContainsNumber(int column, int number)
        {
            for (int i = 0; i < 9; i++)
            {
                if (!data[column, i].IsEmpty && data[column, i].Value == number)
                    return true;
            }
            return false;
        }

        //kontroluje zda řádek obsahuje číslo
        public bool RowContainsNumber(int row, int number)
        {
            for (int i = 0; i < 9; i++)
            {
                if (!data[i, row].IsEmpty && data[i, row].Value == number)
                    return true;
            }
            return false;
        }

        //kontroluje zda čtverec (3x3) ve kterém se nachází obsahuje danné číslo
        public bool BlockContainsNumber(int pos_x, int pos_y, int number) 
        {
            Number[,] block = GetBlock(pos_x, pos_y);
            for (int x = 0; x < 3; x++)
            {
                for (int y = 0; y < 3; y++)
                {
                    if (!block[x, y].IsEmpty && block[x, y].Value == number)
                        return true;
                }
            }
            return false;
        }

        //vrací čtverec(3x3) z pozice v sudoku
        public Number[,] GetBlock(int pos_x, int pos_y)
        {
            Number[,] block = new Number[3, 3];

            int start_x = (int)(Math.Floor((double)pos_x / 3) * 3), start_y = (int)(Math.Floor((double)pos_y / 3) * 3);
            for (int x = start_x; x < start_x + 3; x++)
                for (int y = start_y; y < start_y + 3; y++)
                    block[x - start_x, y - start_y] = data[x, y];

            return block;
        }
    }
}
