#include "vypocet_sudoku.h"

bool povolena_cislica(int s[][9], int riadok, int stlpec, int cislica) {
    // nastavenie prvej bunky regionu 3 x 3
    int region_riadok_start = (riadok / 3) * 3;
    int region_stlpec_start = (stlpec / 3) * 3;
    int i;

    for(i = 0; i < 9; i++) {
        // skontroluje ci cislica splna pravidla v riadku
        if (s[riadok][i] == cislica)
            return false; // nesplna
        // skontroluje ci cislica splna pravidla v stlpci
        if (s[i][stlpec] == cislica)
            return false; // nesplna
        // skontroluje ci cislica splna pravidla v regione
        if (s[region_riadok_start + (i % 3)][region_stlpec_start + (i /3 )] == cislica)
            return false; // nesplna
    }
    return true; // splna vsetky pravidla
}

bool vypocitaj_vsetko(int s[][9], int riadok, int stlpec) {
    int i;

    // ak v bunke nie je nula
    if (s[riadok][stlpec] != 0) {
        // ak sa da prejst na dalsiu bunku rekurzne ju testuje
        if ((stlpec + 1) < 9) {
            return vypocitaj_vsetko(s, riadok, stlpec + 1);
        }
        // ak sa da prejst na dalsiu bunku rekurzne ju testuje
        else if ((riadok + 1) < 9) {
            return vypocitaj_vsetko(s, riadok + 1, 0);
        }
        // ak sa neda prejst na dalsiu bunku, vrati hotovo
        else
            return true;
    }
    else {// ak je v bunke nula
        // testovanie cislic
        for (i = 0; i < 9; i++) {
            // ak splna pravidla, vlozi cislicu do bunky
            if (povolena_cislica(s, riadok, stlpec, i + 1)) {
                s[riadok][stlpec] = i + 1;
                // skontroluje ci je vsetko OK
                if (vypocitaj_vsetko(s, riadok, stlpec))
                    return true;
                else // ak nie, vlozi do bunky nulu
                    s[riadok][stlpec] = 0;
            }
        }
    }
    return false;
}
