<?php
    // RUN: php sudoku.php
    // insert 1.row
    // ...
    // insert 9.row
    // row format example: _ 1 _ _ 3 4 _ 5 _
    
    // vrati false ak sa vlozene cislo uz nachadza v riadku, inak true
    function checkRow($value,$row,$col){
        global $sudoku;
        for($i = 0; $i < 9; $i++){
            if($i != $col){
                if($sudoku[$row][$i] == $value) return false;
            }
        }
        return true;
    }
    
    // vrati false ak sa vlozene cislo uz nachadza v stlpci, inak true
    function checkCol($value,$row,$col){
        global $sudoku;
        for($i = 0; $i < 9; $i++){
            if($i != $row){
                if($sudoku[$i][$col] == $value) return false;
            }
        }
        return true;
    }
    
    // vrati false ak sa vlozene cislo uz nachadza v bloku, inak true
    function checkBlock($value,$row,$col){
        global $sudoku;
        $sCol = $col - $col % 3;
        $sRow = $row - $row % 3;
        for($i = $sRow; $i < $sRow + 3; $i++){
            for($j = $sCol; $j < $sCol + 3; $j++){
                if($i != $row && $j != $col){
                    if($sudoku[$i][$j] == $value) return false;
                }
            }
        }
        return true;
    }

    // vrati false ak cisla v vstupnom sudoku su nekorektne, inak true
    function checkInput(){
        global $sudoku;
        for($col = 0; $col < 9; $col++){
            for($row = 0; $row < 9; $row++){
                if($sudoku[$row][$col] != 0){
                    if(!checkRow($sudoku[$row][$col],$row,$col) || !checkCol($sudoku[$row][$col],$row,$col) || !checkBlock($sudoku[$row][$col],$row,$col)){
                        return false;
                    }
                }
            }
        }
        return true;
    }

    // jednoducha rekurzivna funkcia, kde backtrackuje vhodne cisla pri rieseni sudoku vzhladom k riadku, stlpcu a bloku(3x3)
    function solve(){
        global $sudoku;
        for($col = 0; $col < 9; $col++){
            for($row = 0; $row < 9; $row++){
                if($sudoku[$row][$col] == 0){
                    $result = false;
                    for($i = 1; $i <= 9; $i++){
                        if(checkRow($i,$row,$col) && checkCol($i,$row,$col) && checkBlock($i,$row,$col)){
                            $sudoku[$row][$col] = $i;
                            $result = solve();
                        }
                        if($result == true)return $result;
                        else $sudoku[$row][$col] = 0;
                    }
                    return $result;
                }
            }
        }
        return true;
    }
   
    // vypis sudoku vo formate podla zadania
    function print_solve(){
        global $sudoku;
        for($row = 0; $row < 9; $row++){
            for($col = 0; $col < 9; $col++){
                echo $sudoku[$row][$col];
                echo ($col == 8) ? "\n" : " ";
            }
        }
    }
    
    echo "Please type your sudoku:\n";
    // sudoku[riadok][stlpec] - nacitanie zo vstupu
    for($i=0;$i<9;$i++){
        $sudoku_entry = readline();
        $sudoku_entry = str_replace("_",0,$sudoku_entry);
        $sudoku[$i] = explode(" ",$sudoku_entry);
    }

    if(!checkInput()){
        echo "Number in default sudoku are incorrect!\n";
        return;
    }
    solve();
    print_solve();
?>
